(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define("MyLib", [], factory);
	else if(typeof exports === 'object')
		exports["MyLib"] = factory();
	else
		root["MyLib"] = factory();
})(this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 1);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
exports.BITS = 5;
exports.SHIFT0 = 0;
exports.SHIFT1 = exports.SHIFT0 + exports.BITS;
exports.SHIFT2 = exports.SHIFT1 + exports.BITS;
exports.SHIFT3 = exports.SHIFT2 + exports.BITS;
exports.calculateOffset = function (index, shift) {
    return Math.floor(index / (1 << shift));
};
exports.calculateRow = function (index, shift) {
    return (index >>> shift) & ((1 << exports.BITS) - 1);
};
exports.calculateMask = function (index, shift) {
    return 1 << exports.calculateRow(index, shift);
};
exports.nextPowerOfTwo = function (index) {
    return Math.pow(2, Math.ceil(Math.log(index) / Math.log(2)));
};
exports.copyArrays = function (source, target) {
    if (source) {
        for (var i = 0; i < source.length; i += 1) {
            target[i] = source[i];
        }
    }
    return target;
};


/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

module.exports = __webpack_require__(2);


/***/ }),
/* 2 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
__export(__webpack_require__(3));
__export(__webpack_require__(4));
__export(__webpack_require__(5));


/***/ }),
/* 3 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var Utils_1 = __webpack_require__(0);
var BitSet = /** @class */ (function () {
    function BitSet(size) {
        if (size === void 0) { size = 0; }
        this.capacity = 0;
        this.internalSize = 0;
        this.grow(size);
    }
    BitSet.prototype.grow = function (size) {
        if (this.capacity <= size) {
            var capacity = Utils_1.nextPowerOfTwo(size);
            var p0 = Utils_1.calculateOffset(capacity, Utils_1.SHIFT1);
            var p1 = Utils_1.calculateOffset(capacity, Utils_1.SHIFT2);
            var p2 = Utils_1.calculateOffset(capacity, Utils_1.SHIFT3);
            this.layer0 = Utils_1.copyArrays(this.layer0, new Uint32Array(p0 + 1));
            this.layer1 = Utils_1.copyArrays(this.layer1, new Uint32Array(p1 + 1));
            this.layer2 = Utils_1.copyArrays(this.layer2, new Uint32Array(p2 + 1));
            this.layer3 = Utils_1.copyArrays(this.layer3, new Uint32Array(1));
            this.capacity = capacity;
        }
        if (this.internalSize < size) {
            this.internalSize = size;
        }
    };
    BitSet.prototype.byte = function (index, layer) {
        switch (layer) {
            case 0: return this.layer0[index];
            case 1: return this.layer1[index];
            case 2: return this.layer2[index];
            case 3: return this.layer3[index];
        }
    };
    BitSet.prototype.size = function () {
        return this.internalSize;
    };
    BitSet.prototype.add = function (index) {
        this.grow(index + 1);
        var p0 = Utils_1.calculateOffset(index, Utils_1.SHIFT1);
        var mask = Utils_1.calculateMask(index, Utils_1.SHIFT0);
        var value = this.layer0[p0];
        if ((value & mask) != 0) {
            return true;
        }
        this.layer0[p0] |= mask;
        if (value == 0) {
            this.add_slow(index);
        }
        return false;
    };
    BitSet.prototype.remove = function (index) {
        var p0 = Utils_1.calculateOffset(index, Utils_1.SHIFT1);
        var p1 = Utils_1.calculateOffset(index, Utils_1.SHIFT2);
        ;
        var p2 = Utils_1.calculateOffset(index, Utils_1.SHIFT3);
        var mask = Utils_1.calculateMask(index, Utils_1.SHIFT0);
        var mask1 = Utils_1.calculateMask(index, Utils_1.SHIFT1);
        var mask2 = Utils_1.calculateMask(index, Utils_1.SHIFT2);
        var mask3 = Utils_1.calculateMask(index, Utils_1.SHIFT3);
        if ((this.layer0[p0] & mask) == 0) {
            return false;
        }
        this.layer0[p0] &= ~mask;
        if (this.layer0[p0] != 0) {
            return true;
        }
        this.layer1[p1] &= ~mask1;
        if (this.layer1[p1] != 0) {
            return true;
        }
        this.layer2[p2] &= ~mask2;
        if (this.layer2[p2] != 0) {
            return true;
        }
        this.layer3[0] &= ~mask3;
        return true;
    };
    BitSet.prototype.contains = function (index) {
        var p0 = Utils_1.calculateOffset(index, Utils_1.SHIFT1);
        var mask = Utils_1.calculateMask(index, Utils_1.SHIFT0);
        return p0 < this.layer0.length && ((this.layer0[p0] & mask) != 0);
    };
    BitSet.prototype.add_slow = function (index) {
        var p1 = Utils_1.calculateOffset(index, Utils_1.SHIFT2);
        var p2 = Utils_1.calculateOffset(index, Utils_1.SHIFT3);
        this.layer1[p1] |= Utils_1.calculateMask(index, Utils_1.SHIFT1);
        this.layer2[p2] |= Utils_1.calculateMask(index, Utils_1.SHIFT2);
        this.layer3[0] |= Utils_1.calculateMask(index, Utils_1.SHIFT3);
    };
    return BitSet;
}());
exports.BitSet = BitSet;


/***/ }),
/* 4 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
function one(size) {
    return {
        byte: function (index, layer) {
            return ~0;
        },
        size: function () {
            return size;
        }
    };
}
exports.one = one;
function zero(size) {
    return {
        byte: function (index, layer) {
            return 0;
        },
        size: function () {
            return size;
        }
    };
}
exports.zero = zero;
function maximumSize(sets) {
    return sets.reduce(function (acc, set) {
        return acc >= set.size() ? acc : set.size();
    }, 0);
}
function and() {
    var sets = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        sets[_i] = arguments[_i];
    }
    if (sets.length == 1) {
        return sets[0];
    }
    return {
        byte: function (index, layer) {
            return sets.reduce(function (acc, set) {
                return acc & set.byte(index, layer);
            }, ~0);
        },
        size: function () {
            return maximumSize(sets);
        }
    };
}
exports.and = and;
function xor() {
    var sets = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        sets[_i] = arguments[_i];
    }
    if (sets.length == 1) {
        return sets[0];
    }
    return {
        byte: function (index, layer) {
            return sets.reduce(function (acc, set) {
                return acc ^ set.byte(index, layer);
            }, 0);
        },
        size: function () {
            return maximumSize(sets);
        }
    };
}
exports.xor = xor;
function or() {
    var sets = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        sets[_i] = arguments[_i];
    }
    if (sets.length == 1) {
        return sets[0];
    }
    return {
        byte: function (index, layer) {
            return sets.reduce(function (acc, set) {
                return acc | set.byte(index, layer);
            }, 0);
        },
        size: function () {
            return maximumSize(sets);
        }
    };
}
exports.or = or;
function not(a) {
    return {
        byte: function (index, layer) {
            if (layer != 0) {
                return ~0;
            }
            return ~a.byte(index, layer);
        },
        size: function () {
            return a.size();
        }
    };
}
exports.not = not;


/***/ }),
/* 5 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var count_trailing_zeros_1 = __webpack_require__(6);
var Utils_1 = __webpack_require__(0);
function iterate(a, callback) {
    var iterator = createIterator(a);
    while (true) {
        var _a = iterator.next(), value = _a.value, done = _a.done;
        if (done) {
            break;
        }
        callback(value);
    }
    ;
}
exports.iterate = iterate;
function createIterator(a) {
    return new BitSetIterator(a, [0, 0, 0, a.byte(0, 3)], [0, 0, 0]);
}
exports.createIterator = createIterator;
var BitSetIterator = /** @class */ (function () {
    function BitSetIterator(set, masks, prefix) {
        this.set = set;
        this.masks = masks;
        this.prefix = prefix;
        this.done = false;
    }
    BitSetIterator.prototype.next = function () {
        var value = undefined;
        while (true) {
            if (this.masks[0] != 0) {
                var bit = count_trailing_zeros_1.default(this.masks[0]);
                this.masks[0] &= ~(1 << bit);
                value = this.prefix[0] | bit;
                if (value >= this.set.size()) {
                    this.done = true;
                    value = undefined;
                }
                break;
            }
            if (this.masks[1] != 0) {
                var bit = count_trailing_zeros_1.default(this.masks[1]);
                this.masks[1] &= ~(1 << bit);
                var index = this.prefix[1] | bit;
                this.masks[0] = this.set.byte(index, 0);
                this.prefix[0] = index << Utils_1.BITS;
                continue;
            }
            if (this.masks[2] != 0) {
                var bit = count_trailing_zeros_1.default(this.masks[2]);
                this.masks[2] &= ~(1 << bit);
                var index = this.prefix[2] | bit;
                this.masks[1] = this.set.byte(index, 1);
                this.prefix[1] = index << Utils_1.BITS;
                continue;
            }
            if (this.masks[3] != 0) {
                var bit = count_trailing_zeros_1.default(this.masks[3]);
                this.masks[3] &= ~(1 << bit);
                var index = this.prefix[3] | bit;
                this.masks[2] = this.set.byte(index, 2);
                this.prefix[2] = index << Utils_1.BITS;
                continue;
            }
            this.done = true;
            value = undefined;
            break;
        }
        return { value: value, done: this.done };
    };
    return BitSetIterator;
}());
exports.BitSetIterator = BitSetIterator;


/***/ }),
/* 6 */
/***/ (function(module, exports) {

module.exports = function(v) {
  var c = 32
  v &= -v
  if (v) c--
  if (v & 0x0000FFFF) c -= 16
  if (v & 0x00FF00FF) c -= 8
  if (v & 0x0F0F0F0F) c -= 4
  if (v & 0x33333333) c -= 2
  if (v & 0x55555555) c -= 1
  return c
}


/***/ })
/******/ ]);
});
//# sourceMappingURL=my-lib.js.map