export interface HierarchicalBitset {
    byte(index: number, layer: number): number;
    size(): number;
}
export declare class BitSet implements HierarchicalBitset {
    layer0: Uint32Array;
    layer1: Uint32Array;
    layer2: Uint32Array;
    layer3: Uint32Array;
    capacity: number;
    internalSize: number;
    constructor(size?: number);
    grow(size: number): void;
    byte(index: number, layer: number): number;
    size(): number;
    add(index: number): boolean;
    remove(index: number): boolean;
    contains(index: number): boolean;
    private add_slow(index);
}
