export function one(size) {
    return {
        byte: function (index, layer) {
            return ~0;
        },
        size: function () {
            return size;
        }
    };
}
export function zero(size) {
    return {
        byte: function (index, layer) {
            return 0;
        },
        size: function () {
            return size;
        }
    };
}
function maximumSize(sets) {
    return sets.reduce(function (acc, set) {
        return acc >= set.size() ? acc : set.size();
    }, 0);
}
export function and() {
    var sets = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        sets[_i] = arguments[_i];
    }
    if (sets.length == 1) {
        return sets[0];
    }
    return {
        byte: function (index, layer) {
            return sets.reduce(function (acc, set) {
                return acc & set.byte(index, layer);
            }, ~0);
        },
        size: function () {
            return maximumSize(sets);
        }
    };
}
export function xor() {
    var sets = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        sets[_i] = arguments[_i];
    }
    if (sets.length == 1) {
        return sets[0];
    }
    return {
        byte: function (index, layer) {
            return sets.reduce(function (acc, set) {
                return acc ^ set.byte(index, layer);
            }, 0);
        },
        size: function () {
            return maximumSize(sets);
        }
    };
}
export function or() {
    var sets = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        sets[_i] = arguments[_i];
    }
    if (sets.length == 1) {
        return sets[0];
    }
    return {
        byte: function (index, layer) {
            return sets.reduce(function (acc, set) {
                return acc | set.byte(index, layer);
            }, 0);
        },
        size: function () {
            return maximumSize(sets);
        }
    };
}
export function not(a) {
    return {
        byte: function (index, layer) {
            if (layer != 0) {
                return ~0;
            }
            return ~a.byte(index, layer);
        },
        size: function () {
            return a.size();
        }
    };
}
//# sourceMappingURL=Operations.js.map