"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var count_trailing_zeros_1 = require("count-trailing-zeros");
var Utils_1 = require("./Utils");
function iterate(a, callback) {
    var iterator = createIterator(a);
    while (true) {
        var _a = iterator.next(), value = _a.value, done = _a.done;
        if (done) {
            break;
        }
        callback(value);
    }
    ;
}
exports.iterate = iterate;
function createIterator(a) {
    return new BitSetIterator(a, [0, 0, 0, a.byte(0, 3)], [0, 0, 0]);
}
exports.createIterator = createIterator;
var BitSetIterator = /** @class */ (function () {
    function BitSetIterator(set, masks, prefix) {
        this.set = set;
        this.masks = masks;
        this.prefix = prefix;
        this.done = false;
    }
    BitSetIterator.prototype.next = function () {
        var value = undefined;
        while (true) {
            if (this.masks[0] != 0) {
                var bit = count_trailing_zeros_1.default(this.masks[0]);
                this.masks[0] &= ~(1 << bit);
                value = this.prefix[0] | bit;
                if (value >= this.set.size()) {
                    this.done = true;
                    value = undefined;
                }
                break;
            }
            if (this.masks[1] != 0) {
                var bit = count_trailing_zeros_1.default(this.masks[1]);
                this.masks[1] &= ~(1 << bit);
                var index = this.prefix[1] | bit;
                this.masks[0] = this.set.byte(index, 0);
                this.prefix[0] = index << Utils_1.BITS;
                continue;
            }
            if (this.masks[2] != 0) {
                var bit = count_trailing_zeros_1.default(this.masks[2]);
                this.masks[2] &= ~(1 << bit);
                var index = this.prefix[2] | bit;
                this.masks[1] = this.set.byte(index, 1);
                this.prefix[1] = index << Utils_1.BITS;
                continue;
            }
            if (this.masks[3] != 0) {
                var bit = count_trailing_zeros_1.default(this.masks[3]);
                this.masks[3] &= ~(1 << bit);
                var index = this.prefix[3] | bit;
                this.masks[2] = this.set.byte(index, 2);
                this.prefix[2] = index << Utils_1.BITS;
                continue;
            }
            this.done = true;
            value = undefined;
            break;
        }
        return { value: value, done: this.done };
    };
    return BitSetIterator;
}());
exports.BitSetIterator = BitSetIterator;
//# sourceMappingURL=Iteration.js.map